package com.unipi.talepis.protal2023_5;

import android.app.Notification;
import android.app.NotificationChannel;
import android.app.NotificationManager;
import android.app.Service;
import android.content.Intent;
import android.os.IBinder;
import android.util.Log;

public class MyService extends Service {
    private static volatile Boolean running;
    public MyService() {
    }

    @Override
    public int onStartCommand(Intent intent, int flags, int startId) {
        /*try {
            Thread.sleep(2000);//very bad practice on main thread...
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
        Log.e("message","Hello");*/
        if (intent.getAction().equals("STOP_SERVICE")){
            stopForeground(true);
            stopSelf();
        }
        Thread t = new Thread(
                () -> {
                    while (running) {
                        Log.e("Service", "Service is running...");
                        try {
                            Thread.sleep(2000);
                        } catch (InterruptedException e) {
                            e.printStackTrace();
                        }
                    }
                }
        );
        running = true;
        t.start();
        NotificationChannel channel = new NotificationChannel(
                "CHANNELID",
                "CHANNELID",
                NotificationManager.IMPORTANCE_LOW
        );
        getSystemService(NotificationManager.class).createNotificationChannel(channel);

        Notification.Builder notification = new Notification.Builder(this,"CHANNELID")
                .setContentText("My foreground service is running")
                .setContentTitle("Service Message")
                .setSmallIcon(R.drawable.ic_launcher_background);

        startForeground(1001,notification.build());

        return START_NOT_STICKY;
    }

    @Override
    public IBinder onBind(Intent intent) {
        // TODO: Return the communication channel to the service.
        throw new UnsupportedOperationException("Not yet implemented");
    }

    @Override
    public void onDestroy() {
        running = false;
    }
}